close all;
clear;

addpath('../common');
directory = '../data/';

%% Specify data set
data_set = 'tom';

% Other data sets can be downloaded from http://vision.middlebury.edu/flow/data/
%data_set = 'army';
%data_set = 'mequon';
%data_set = 'urban';
%data_set = 'rubberWhale';
%data_set = 'venus';

%% Use structure-texture decomposition?
st = 1;

%% load input images
[I1, I2] = load_images(directory, data_set, st);


%%
% algorithm parameters
lambda = 40.0;
epsilon = 0.01;
warps = 10;
pyramid_factor = 0.5;
pyramid_levels = 1000;

%% Start algorithm
tic
  flow = coarse_to_fine(I1, I2, lambda, epsilon, warps, pyramid_levels, pyramid_factor);
toc

%% Output
flowfile = strcat('../results/', data_set,'_TVL1.flo');
pngfile = strcat('../results/', data_set,'_TVL1.png');
writeFlowFile(flow,flowfile);
magnitude = (flow(:,:,1).^2 + flow(:,:,2).^2).^0.5;  
max_flow = prctile(magnitude(:),97);
flow = max(-max_flow, min(max_flow, flow));
imwrite(uint8(flowToColor(flow)),pngfile);
